/*Ŀ
 ݳ This program shows various methods of coping with problems when your 
 ݳ program incounters errors opening databases.                         
 ݳ                                                                      
 ݳ It is not intended to be used as is, but to be for examining methods 
 ݳ of stopping these errors.                                            
 ݳ                                                                      
 ݳ All types of errors are not covered in full, such as:                
 ݳ Using CA-Clipper's file I/O functions to read a .dbf to see if a     
 ݳ memo file is required.                                               
 ݳ                                                                      
 ݳ NOTE: I did not cover indice files since there are so many types now!
 ݳ                                                                      
 
            */

/*****
 *
 *   Application: General Purpose Routine
 *   Description: AChoice()-style menu
 *     File Name: CHOICE.PRG
 *        Author: Luiz Quintela
 *  Date created: 12-30-92
 *     Copyright: 1992 by Computer Associates
 *
 */

#define BUTTOM_COLOR         "GR+/N"
#define BAR_BGND_COLOR       "N/N"
#define BROW_DEFAULT_COLORS  "W+/RB,W+/N,W+/W"

#include "inkey.ch"

// #define NANNY
// #define MR_GRUMP

#ifndef MR_GRUMP
#define SaveFullScreen() oldscreen := savescreen( 0, 0, maxrow(), maxcol() )
#define RestFullScreen() restscreen( 0, 0, maxrow(), maxcol(), oldscreen )
#endif

/*****
 *
 *         Name: AChoose()
 *  Description: AChoice() replacement
 *       Author: Luiz Quintela
 * Date created: 12-30-92
 *    Copyright: Computer Associates
 *   Tweaked by: Kevin S. Gallagher
 * Date tweaked: 03/27/93
 *             :
 *    Arguments: nTop
 *             : nLeft
 *             : nBottom
 *             : nRight   
 *             : aItems   - Array with Menu Items
 *             : aLogic   - Array with .T. or .F. for each item in menu
 *             : cClrStr  - Color pattern (as a string)
 *             : nBoxType - either double or 3d
 * Return Value: nRet     - Subscript
 *     Comments: May 1993 - Kevin S. Gallagher
 *             : The code gets hacked to use in this program!
 *             : I remodified it to use in the RDD errorSystem
 *             : If you want to use grump.lib calls, then define MR_GRUMP
 *             : Also for nanfor.lib define NANNY
 *             : Both above libraries are UnDefined as delivered..
 */

FUNCTION AChoose( nTr, nTc, nBr, nBc, aItems, aLogic, cColor, nBoxType )

    LOCAL oBrow, nKey, oCols, nNewPos, nLen, nInitPos, nWindow
    LOCAL nWidth, cSaveClr, nSubs, nRet, nActually

    #ifndef MR_GRUMP
       LOCAL SaveFullScreen()
    #endif

    nLen    := Len( aItems )
    cColor  := if(cColor == nil, BROW_DEFAULT_COLORS, cColor)
    nBoxType:= if(valtype(nBoxType) == "N", nBoxType, 1 )


    #ifdef MR_GRUMP
       gfsaveenv( { nTr -1, nTc -1, nBr +3, nBc +4 }, SC_NONE, cColor )
    #endif

    if ValType(aLogic) != "A"
        aLogic := Array(nLen)
        afill( aLogic, .T. )
    endif

    nInitPos := 0
    nWindow  := nBr - nTr
    nWidth   := nBc - nTc - 1
    nRet     := 0

    cSaveClr := SetColor( Substr(cColor, 1, At(",",cColor) - 1))

    if nBoxType == 1
        dispbox(nTr -1, nTc -1, nBr +1, nBc +1,'ͻȺ ')
        dispbox(nTr,nBc+1,nBr,nBc+1,chr(219),BAR_BGND_COLOR)
        @ nTr,nBc + 1 say chr(219) color BUTTOM_COLOR
        #ifdef NANNY
           ft_shadow(nTr,nTc,nBr+1,nBc+1,7)
        #endif
    #ifdef BUCK_ROGERS
    elseif nBoxType == 2
        box3d(nTr-1,nTc-1,nBr+1,nBc+1,B_SINGLE+" ","B")
    #endif
    endif

    oBrow:=tbrowsenew( nTr, nTc, nBr, nBc )
    oBrow:colorspec := cColor

    nSubs:= 1

    oBrow:gotopblock    := {|| nSubs := 1 }
    oBrow:gobottomblock := {|| nSubs := nLen }
    oBrow:skipblock := {|nRequest| nActually := if(Abs(nRequest) >= ;
                           if(nRequest >= 0,;
                              nLen - nSubs, nSubs - 1),;
                                 if(nRequest >= 0, nLen - nSubs,;
                                    1 - nSubs),nRequest),;
                                       nSubs += nActually, ;
                                          nActually }

    oCols:= tbcolumnNew(, { || aItems[nSubs] } )
    oCols:colorblock :=   { || if( aLogic[nSubs], {1, 2}, {1, 3} ) }
    oCols:width      := nWidth
    oBrow:addcolumn(oCols)

    while .t.
        dispbegin()
        oBrow:forcestable()
        /*
        while !oBrow:Stabilize()
        enddo
        */
        dispend()

        if oBrow:hittop .or. oBrow:hitbottom
            tone(5000,1)
        endif

        // Update Bar Gauge
        nNewPos := nWindow / (nLen / nSubs)
        if nSubs == 1
            nNewPos := 0
        elseif nSubs == nLen
            nNewPos := nWindow
        endif
        if ( nInitPos != nNewPos )
            if nBoxType == 1
                @ nTr + nInitPos,nBc + 1 say chr(219)  color BAR_BGND_COLOR
                @ nTr + nNewPos, nBc + 1 say chr(219)  color BUTTOM_COLOR
            endif

            nInitPos := nNewPos
        endif

        nKey := inkey(0)

        do case
            case nKey == K_DOWN .or. nKey == K_RIGHT
                oBrow:down()
            case nKey == K_UP .or. nKey == K_LEFT
                oBrow:up()
            case nKey == K_ENTER
                if aLogic[nSubs]
                    nRet := nSubs
                    EXIT
                else
                    alert("ALREADY ATTEMPTED;THIS DRIVER AND IT FAILED")
                    loop
                endif
            case nKey == K_PGDN
                oBrow:pagedown()
            case nKey == K_PGUP
                oBrow:pageup()
            case nKey == K_ESC .or. nKey == 81 .or. nKey == 113
                nRet := len(aItems)
                EXIT
        endcase
    enddo
    #ifdef MR_GRUMP
       gfrestenv()
    #else
      setcolor(cSaveClr)
      RestFullScreen()
    #endif
return (nRet)






