/*Ŀ
 ݳ                                                                      
 ݳ Program Name: TEST.PRG          Copyright: Gallagher Computing Corp. 
 ݳ     Language: Clipper 5.2         Compile: test /m/n                 
 ݳ       Author: Kevin S Gallagher            choice /m/n               
 ݳĳ
 ݳ This program shows various methods of coping with problems when your 
 ݳ program incounters errors opening databases.                         
 ݳ                                                                      
 ݳ It is not intended to be used as is, but to be for examining methods 
 ݳ of stopping these errors.                                            
 ݳ                                                                      
 ݳ All types of errors are not covered in full, such as:                
 ݳ Using CA-Clipper's file I/O functions to read a .dbf to see if a     
 ݳ memo file is required.                                               
 ݳ                                                                      
 ݳ NOTE: I did not cover indice files since there are so many types now!
 ݳ                                                                      
 
            */

#include "error.ch"
#include "box.ch"

// Start manifest constants
#define DEFAULT_DRIVER  ascan(RDDLIST(),"DBFCDX")
#define CLIPGEN         oMy:gencode
#define CLIPDOS         oMy:oscode
#define NO_FILE         2
#define bSortNames      { | x , y | x[1] < y[1]})
// end manifest constants

#xtranslate LSTRINT( <n> ) => LTRIM( STR( INT( <n> ) ) ) 

// Greg Lief code from grump.lib
#xtranslate AKill( <a>, <e> ) => asize( adel( <a>, <e> ), len( <a> ) - 1 )


#ifdef TEST
function main
    local aRetVal_
    // files to open
    // x.dbf and y.dbf do not exist
    // help.dbf uses DBFNTX or DBFNDX or DBFMDX
    // you may want to delete help.dbt on a second pass
    // cat.dbf uses DBFCDX
    local aOpenFile_ := { "X.DBF","Y.DBF","HELP.DBF","CAT.DBF" }
    local jj:=0


    /*
    * attempt to open all files in the array
    */
    aRetVal_ := OpenFiles( aOpenFile_ )

    /*
    * Evaluate the array values returned from the function OpenFiles()
    * and display the files that opened OKay, and also the files that
    * failed to open..
    */
    @0,0 say padc("File(s) that were opened",80) color "gr+/b"
    setpos(1,0)
    aeval( aRetVal_ ,{|a| QOut("  "+a)})
    dispbox(1,0,6,maxcol(),B_SINGLE,"b+/n" )
    @7,0 say padc("File(s) that did not open",80) color "w+/r"
    setpos(8,0)
    for jj := 1 to len(aOpenFile_)
        if ( ascan(aOpenFile_, aRetVal_[jj]) ) == 0
            qout("  "+aOpenFile_[jj])
        endif
    next
    dispbox(8,0,13,maxcol(),B_DOUBLE,"r+/n")
    setpos(15,0)
return nil
#endif

function OpenFiles( aDbfList_ )
    local oMy
    local bOldHandler := ERRORBLOCK( { |oErr| BREAK(oErr) } )
    local nLen :=0
    local jj :=1
    local xx := DEFAULT_DRIVER
    local Files_   :={}
    local aDrivers_:= RDDLIST()
    local aLogic   := {}
    local aFiles_  := {}
    local lRetVal  := .T.
    local cSmScrn

    /*
    * add an option to quit, if it has not been added from prior calls
    */
    if ( ascan(RDDLIST(),"QUIT") ) == 0
        aadd( aDrivers_ ,"QUIT")
    endif
    
    if ( nLen := len( aDbfList_ ) ) <> 0
        aFiles_ := aclone( aDbfList_ )
        aLogic  := Array( len(aDrivers_) )
        AFill( aLogic, .T. )
        while jj <> nLen +1
            /*
            * loop through the array of databases to open
            */
            begin sequence
                USE ( aFiles_[jj] ) VIA (aDrivers_[xx]) NEW
                jj++ 
                xx := DEFAULT_DRIVER
            recover  using oMy
            
                if CLIPGEN == EG_ARG
                    // If we get this messge we did a BooBoo
                    alert("PROGRAMMERS ERROR",{" A BooBoo "})
                endif
                if "DB" $ LEFT(oMy:subsystem,2) 
                    // Gota file problem of some sort!
                    do case
                        case CLIPGEN == EG_DUPALIAS .or. CLIPDOS == NO_FILE
                            // attempt to open a file already open
                            // or the file was not located
                            // give the user a selection box to retry
                            aFiles_[jj] := GetDbf( aFiles_[jj] )
                            loop
                        case CLIPGEN == EG_CORRUPTION
                            // possiblity of error
                            // wrong driver
                            // missing memo file
                            // encrypted file
                            // disallow selection of failed RDD
                            aLogic[ DEFAULT_DRIVER ] := .f.
                            xx:= SelectDriver( oMy, aDrivers_, aLogic )
                            if aDrivers_[xx] == "QUIT"
                                setcolor("w/n")
                                cls
                                eval( bOldhandler, oMy )
                            else
                                rddsetdefault( aDrivers_[xx] )
                                LOOP
                            endif
                        otherwise
                            eval( bOldhandler, oMy )
                    endcase
                endif
                ERRORBLOCK( bOldhandler )
            end sequence
        enddo
        errorblock( bOldhandler )
    endif

    #ifdef TEST
    // Fill an array of files that opened successfully
    jj:=0
    for jj:= 1 to 100
        select(jj)
        if !empty(alias())
            aadd(Files_,alias()+".DBF")
            #ifdef JERKY
                 chr(32)+chr(32)  +;
                 Padr(alias(),20) +;
                 chr(179)+chr(32) +;
                 padr(RDDNAME(),7)+;
                 chr(179)+chr(32) +;
                 LSTRINT(jj);
            )
            #endif
        endif
    next
    #endif

#ifdef TEST    
   return Files_
#else
   return lRetVal
#endif

function SelectDriver( oError, aDrivers_, aLogic )
    local oMy, bOldHandler:= errorblock( { |oErr| BREAK(oErr) } )
    local oldcolor:= setcolor("gr+/b"), jj, lExit :=.t.
    local oldscrn := savescreen(0,0,maxrow(),maxcol())
    while lExit
        begin sequence
            dispbox(0,0,maxrow(),maxcol(),B_SINGLE+" ","bg+/b")
            @ 3,2  say "      CLIPPER CODE: "
            @ 2,2  say "ERROR OPENING FILE: "
            @ 4,2  say "       CALLED FROM: "
            @ 5,2  say "       LINE NUMBER: "
            @ 6,2  say "         SUBSYSTEM: "
            @ 7,2  say "         OPERATION: "
            @ 8,2  say "          REMEDIES: "
            setcolor("w+/b")
            @ 2,22 say oError:filename
            @ 3,22 say "CORRUPTION DETECTED"
            @ 4,22 say PROCNAME(1)
            @ 5,22 say LSTRINT( PROCLINE(1) )
            @ 6,22 say oError:subsystem
            @ 7,22 say if(!empty(oError:operation),oError:operation,"N/A")
            @ 8,22 say "Try another driver"
            @ 9,22 say "File may be encrypted"
            @10,22 say "File may be missing a memo file"

            /*
            * present valid list of available RDDs to select from
            * the error box offers a few reasons why the file didn't open
            * and is not a complete list!
            */
            if ( jj := AChoose( 13,10,19,40,aDrivers_,aLogic)) == 0 .or. ;
                 jj == len(aDrivers_ ;
                )

                setcolor("w+/r")
                dispbox(0,0,10,maxcol(),B_DOUBLE+" ","W+/R")
                @1,2 say "    Error opening: "+oError:filename
                @2,1 say replicate(chr(196),78)
                @3,2 say "Possible problems:"
                @4,2 say "- You did not try all the drivers available"
                @5,2 say "- The file is missing a memo file (.dbt/.fpt)"
                @6,2 say "- "+lower(oError:filename)+ ;
                         " or its memo file are corrupt"

                @7,2 say "Possible remedies:"
                @8,2 say "- Verify there is no encryption on this file."
                @9,2 say "- Run a file diaganostic program such"+ ;
                         " as Norton's FileFix"

                setcolor("w/n")
                scroll(11,0,maxrow(),maxcol()) ;  setpos(12,0)
                quit
            else
                lExit :=.f.
            endif
            restscreen(0,0,maxrow(),maxcol(),oldscrn)
            setcolor(oldcolor)
        recover using oMy
            eval( bOldhandler, oMy )
        end sequence
    enddo
    ERRORBLOCK( bOldhandler )
return jj

function GetDbf( cDup )
    local x,aList_:={}, jj:=0, nKillIt
    local cMsg:= " -> MAY BE CORRUPT  MISSING A MEMO FILE  ENCRYPTED?"
    aeval( asort(directory("*.DBF"),,,bSortNames,{|a| aadd(aList_,a[1])}  )
    @0,0 say padr(" "+cDup+if(!file(cDup)," MISSING",cMsg),80) color "w+/r"
    for jj:= 1 to 255
        select(jj)
        if !empty(alias())
            if ( nKillIt := ascan(aList_,alias()+".DBF") ) <> 0
                akill( aList_, nKillIt )
            endif
        endif
    next

    aadd(aList_,"ABORT")

    while .t.
        if ( x := AChoose(10,10,15,40, aList_ ) ) == 0 .or. x == len(aList_)
            alert("ABORTED")
            quit
        else
            exit
        endif
    enddo
return aList_[x]
*****************************************************************************
* default CA-Clipper RDD stuff *
*****************************************************************************
ANNOUNCE RDDSYS

procedure rddinit()
   request DBFNTX
   request DBFMDX
   request DBFNDX
   request DBFCDX
   rddsetdefault('dbfcdx')
return

*****************************************************************************
* initial code to carry out prior to main() *
*****************************************************************************
init procedure HaHa
    setcursor(0)
    cls
return

*****************************************************************************
* coding to execute on termination of program *
*****************************************************************************
exit procedure SoLong
    dbUnlockAll()
    dbcloseall()
    setcolor("w/n")
    if errorlevel() <> 0
        // pause incase the calling program is going to clear the con..
        inkey()
        OUTERR(chr(13))
        OUTERR(chr(13)+"*****PRESS ANY KEY TO QUIT*****")
        inkey(0)
    endif
    setcursor(1)
return
